---
title: Investigation of the successor representation for neuro-computational models of the hippocampus
thanks: I would like to thank Julien Vitay for the supervision of this work and the Artificial Intelligence team of Chemnitz University for its warm welcome. Internship from May 13 until August 16, 2019
author:
  - name: Romain Ferrand
    inst_number: [2]
    #orcidID: 294
  - name: Julien Vitay
    inst_number: [1]
    #orcidID: 12
author_running: R. Ferrand, J. Vitay
title_running: SR for hippocampus models
institute:
  - name: Faculty of Computer Science, Chemnitz University of Technology, Straße der Nationen 62, D-09107 Chemnitz, Germany
    email: dekanat@informatik.tu-chemnitz.de
    url: https://www.tu-chemnitz.de/informatik/KI/index.php.en
  - name: École normale supérieure de Rennes, Campus de Ker Lann, Avenue Robert Schuman, 35170 BRUZ, France
    email: david.pichardie@ens-rennes.fr
    url: http://www.ens-rennes.fr
abstract: Successor representations (SR) is a novel trade-off between model-free and model-based reinforcement learning (RL) which has been used to explain several neurobiological findings, including dopaminergic reward prediction errors. \cite{stachenfeld2017hippocampus} showed that it can be used to explain the formation of place and grid cells in the hippocampal. This paper re-implement this model and provide a new multi-timescale algorithm of the SR along with a neurobiologically feasible actor-critic framework. Finally we study the properties of these models in the context of a Tolman's maze, goal-directed experiments and its capacity of automatically find subgoals using clustering.
keywords:
  - Reinforcement learning
  - Goal-directed decision
  - Place fields
  - Hippocampus
  - Successor representation
citation-style: ../src/llncs.cls
bibliography: ../bib/papers.bib
---


# Introduction # {.unnumbered}

The hippocampus is a brain region particularly known for its importance in spatial navigation and spatial memory \cite{andersen2006hippocampus}. These cognitive functions are expressed through a commonly accepted theory called *the cognitive map theory of the hippocampus* \cite{o1978hippocampus}.

This theory suggests that the hippocampus, builds an *allocentric* or an absolute representation of the local environment, uses this representation for navigation purposes and maintains an independent spatial memory system obeying to specific learning rules.
This theory also argues for the responsibility of the hippocampus in the storage and retrieval of episodic information and even linguistic memory for humans. \cite{andersen2006hippocampus}


## Place-cells and place-fields ## {.unnumbered}

This mapping system implies the existence of a neural substrates which will encode spatial position: the *place-cells*. In the context of free-moving animal, *place-cells* are neurons whose firing rate increase from low to high frequency when the animal get closer to a specific location in space called the *place-field*.
For the sake of completeness, we also introduce another neural substrate which also code for spatial representations, the *grid-cells*.

*Grid-cells* are located inside the *entorhinal cortex* which is in close interaction with the *hippocampus*.
A grid-cell acts similarly to a place-cell except that grid-cells have multiples activation point in space.
Thanks to these activation points, grid-cells create a triangular paving of the local environment.
Grid-cells activation field are locally invariant in size, orientation and spacing, these properties are presumed to allow distance estimation \cite{hafting2005microstructure}. Grid-cells, contrary to place-cells can also be left unchanged when the environment is subject to slight changes. \cite{fyhn2007hippocampal}

## Place-cells and the goal encoding problem ## {.unnumbered}

Representation and spatial navigation are major challenges for animal survival, as they allow to identify dangers, food or sexual partners and to use these information to plan actions towards a goal.
According to the *cognitive map theory of the hippocampus*, *place-cells* are activated for and when the animal is located at a specific point in space.
Because a goal is by definition a position which is not yet reached, this representation does not allow to encode goal location.
\cite{POUCET201751} argues that if the goals are encoded by *place-cells*, the *cognitive map theory* leads to an ambiguity about whether the cell is activated according to a goal or according to the position of the animal.

However, experimental evidence has shown the importance of *place-cells* for goal encoding, and in return *place-cells* are shaped with respect to the path towards the goal (i.e, *place-cells* firing rate is behavior-dependent) \cite{POUCET201751}.
@Fig:replay_hippo taken from \cite{carr2011hippocampal} show that at rest rodents are capable to replay in both forward (left-frame) and backward (right-frame) direction the *place-cells* sequence activated during an experimented path (middle-frame).
This phenomenon called *hippocampal replay* also advocate for the behavioral dependence of the *place-cells*.

![From \cite{carr2011hippocampal} experienced place-cells are re-activated in sequence during forward and backward replay](../img/replay_hippocampus.jpg){#fig:replay_hippo weight=40% height=20%}

These different observations led to the development of a new theory of the hippocampus, *the hippocampus as predictive map* \cite{stachenfeld2017hippocampus}.

## Predictive hippocampus and successor representation ## {.unnumbered}

The predictive theory of place cells may be summed up through the idea in which *place-cells* do not encode the position of the animal *per se*, but rather its probable future positions.
This vision is behavior and topology dependent and thus coherent with experimental findings and goal encoding capacity.
\cite{stachenfeld2017hippocampus} proposed a reinforcement learning framework for this theory using the *successor representations* introduced by Dayan \cite{dayan1993improving}.

The successor representation is know to be a tread-off between model-based and model-free reinforcement learning: it encode a Markovian state in terms of the discounted probability of future reachable states.
In doing so, this representation makes it possible to convey topological and behavioral similarities between the states. We will review this claim in detail on the following sections.

## Successor representation and limitations ## {.unnumbered}

In this paper we wanted to study the principles of various algorithms using the successor representation.
First, we ask the question of realism: which structure should we choose to model a known neuro-cognitive system?
We then study the significance of their hyperparameters: the successor representation depends on a discount rate "gamma" that determines the speed at which a relationship between two states becomes less important.
Finally we study the form and properties of the algorithms by simultaneously using different forgetting parameters.

In section (\ref{RL}), we will introduce reinforcement learning with a concise overview of methods for solving RL problems.
In section (\ref{SR}), we will study in detail the successor representation framework as well as a variant using multiple time-scales called *multi-scale SR*. We will then present our contribution in the form of a new actor-critic algorithm *SR-TD distance* in section (\ref{results}).
Finally in section (\ref{discussion}), we will discuss the extent of our results and the future work that could be carried out.

# Reinforcement learning introduction # {#RL}

According to \cite{sutton2011reinforcement}, the aim of reinforcement learning (RL) is "to map situations to actions".
In RL, an agent receives a partial or perfect observation of its environment, allowing it to create an internal representation (its *state*). Depending on this state, the agent can perform *actions* which modify the state of the environment and bring it to a new state. After the action, the agent also receives a scalar reward (good or bad) judging its previous action.
The goal of RL is to maximize the reward intake over the lifetime of the agent.

## Markov decision process ##

*Markov decision process* (MDP) is mathematical framework for modeling sequential decision making, and thus a suitable instrument to formally model RL problems.
We will see that a MDP can be written in the form of a *Bellman equation*, ensuring the existence of an optimal *policy of actions*.

### Finite Markov decision process ###

A finite markov decision process is a tuple: $$\mathcal{M} = (\mathcal{S}, \mathcal{A}(s), \mathcal{R}, P, R, \gamma, H)$$
where $\mathcal{S}$ is a set of states, $\mathcal{A}(s)$ is the set of actions available in state $s$, $P$ is the transition function, $R$ the reward function, $\gamma$ a discount parameter ($\gamma \in [0, 1]$) and $H$ the horizon ($H \in \mathbb{N} \cup \{\infty\}$). We note $t\in \mathbb{N}$ the discrete time step at which the agent interacts with the environment.

At each time step $t$, we have three random variables: the state $S_t \in \mathcal{S}$, the action taken $A_t \in \mathcal{A}(S_t)$, and the received reward $R_{t+1} \in \mathcal{R}$.
By convention the reward is indexed by $t+1$ and not $t$ to emphasize that $R_{t+1}$ is a result from the action $A_t$ taken in $S_t$ state. If $H < \infty$, $R_{t} = 0$ for $t \geq H$.

@Fig:MDP shows the dynamics between these random variables.

![Markov decision process](../img/MDP.pdf){#fig:MDP width=50% height=20%}

$P$ defines the states dynamics or state-transition probabilities of the MDP:
\begin{align}
  P \colon \mathcal{S} \times \mathcal{A} \times      \mathcal{S} &\to [0,1] \nonumber \\
  (s',a,s) &\mapsto P(s' | a, s) = \Pr\{S_{t+1}=s' | S_t=s, A_t=a\}
\end{align}

$R$ represents the reward distribution for each state-action pair:
\begin{align}
  R \colon \mathcal{S} \times \mathcal{A} &\to [0,1] \nonumber \\
  (s,a) &\mapsto R(s, a) = R_{t+1}
\end{align}

Finally, we define $G_t$ the discounted reward from $t$:
\begin{align}
  G_t &= \sum\limits_{k=t}^{\infty} \gamma^k R(S_{t+k}, A_{t+k}) \nonumber \\
        &= \sum\limits_{k=t}^{\infty} \gamma^k R_{t+k+1}
\end{align}

### Optimal control problem ###

The objective of RL and optimal control problems in general is, given a MDP $\mathcal{M}$,
to find the optimal policy $\pi^{*}$ that *maximizes* the expected discounted reward:
\begin{align}
  \pi^{*} = \argmax_{\pi} \mathbb{E}_{\pi}[G_0]
\end{align}
$\pi$ define the agent's policy as a distribution over the actions:
\begin{align}
  A_t \sim \pi(S_t) &= \Pr\{A_t | S_t\} \nonumber \\
                    &= \pi(A_t | S_t)
\end{align}

### State-value and action-value functions ###

Because the policy $\pi^*$ maximizes the reward of each infinite sequence of rewards, it must in particular maximize $G_t$ when the state $S_t$ or the state-action pair ($S_t, A_t)$ is fixed.
This leads to the definition of the *state-value function*:
\begin{align}
  v^{\pi}(s) &= \mathbb{E}_{\pi}[G_t | S_t = s]
\end{align}
and the *action-value function*:
\begin{align}
  Q^{\pi}(s,a) &= \mathbb{E}_{\pi}[G_t| S_t = s, A_t = a]
\end{align}
These equations satisfy recursive relationships called the *Bellman equations*[^1]:
\begin{align}
v^{\pi}(s)  &= \mathbb{E}_{\pi}[G_t | S_t = s] \nonumber \\
            &= \mathbb{E}_{\pi}[R_t + \gamma G_{t+1}| S_{t+1} = s] \nonumber \\
            &= \sum\limits_{a \in \mathcal{A}(s)} \pi(a|s) \sum\limits_{s' \in \mathcal{S}} P(s' | s, a)[R(s,a) + \gamma\mathbb{E}_{\pi}[G_{t+1}| S_{t+1} = s']], \quad\forall s \in \mathcal{S}
\end{align}
\begin{align}
  Q^{\pi}(s,a)  &= \mathbb{E}_{\pi}[G_t | S_t = s, A_t = a]\nonumber \\
                &= \mathbb{E}_{\pi}[R_t + \gamma G_{t+1}| S_{t+1} = s' , A_{t+1}= a' ] \nonumber \\
                &= \sum\limits_{s' \in \mathcal{S}} [R(s,a) + \sum\limits_{a' \in \mathcal{A}(s')} \gamma\mathbb{E}_{\pi}[G_{t+1}| S_{t+1} = s' , A_{t+1} = a']], \quad\forall (s,a) \in \mathcal{S} \times \mathcal{A}(s)
\end{align}

[^1]: The value and action-value functions are implicitly indexed by $t$, this is the common notation.

## Approximation of states

In the previous section, we spoke about state *per se*, meaning that each $s \in \mathcal{S}$ is an alias for a precise configuration of the environment.
This is generally not a realistic description, because it supposes a perfect and complete information on the environment state, while animals or robots are limited by their sensory abilities (i.e. human cannot generally see behind them).

Moreover, even if it were possible to obtain a perfect view of the environment, the number of states of most problems would be too huge to be stored in memory.
According to \cite{mnih2015human}, which provides a deep RL neural network able to solve Atari video games, a raw frame of an Atari game is a $210$ by $160$ pixels image with $128$-color palette, what would account for a number of distinct states in the magnitude of $10^{512}$ elements.

For these reasons, we have to use approximation methods to compute the state or action value functions.
Each state $s \in \mathcal{S}$ is associated with a feature vector $\varphi(s) \in \mathbb{R}^{n}$, $\varphi$ being called a *feature extraction method*.
This extraction can consist of a simple sensory readout, or a binary encoding for the presence or absence of specific elements (i.e. a classifier), but generally the relevant features are unknown and require a feature extraction process.

Unsupervised methods such as auto-encoder can be used for automatic features extraction but feature engineering still require expert knowledge about the raw data.

Finally, after extraction, we use an approximator $\hat{v}_{\theta}(s)$ or $\hat{q}_{\theta}(s,a)$ parameterized by $\theta \in \mathbb{R}^{d}$, where $d << |\mathcal{S}|$.
$\hat{v}_\theta$ and $\hat{q}_\theta$ can be any desired approximation function: linear regression, neural network, etc.
All the following algorithms can be adapted with function approximation.


## Solving methods for MDPs ##

In this section, we present the main methods allowing to use value-functions to solve MDPs in the RL framework.
Because they are not used in this work classic methods like *Dynamic programming* and *Monte Carlo* are postpone to the appendix (\ref{sol_methods}).

### Temporal difference learning ###

Temporal difference learning or TD learning is a *bootstraping* model-free solving method, meaning that TD learning updates estimates of state or action value based on other estimates.

The idea of TD learning is to estimate $v^{\pi}(S_t)$ by sampling a $n$-lookup path from the MDP graph.
For example $0$-lookup, or TD($0$) is equivalent to sampling $R_t+1$ and $v^{\pi}(S_{t+1})$:
\begin{align}
  v^{\pi}(S_t) = v^{\pi}(S_t) + \alpha[R_{t+1} + \gamma v^{\pi}(S_{t+1}) - v^{\pi}(S_t)]
\end{align}
The other extreme case, TD($\infty$) is equivalent to sampling $G_t$:
\begin{align}
  v^{\pi}(v) = v^{\pi}(S_t) + \alpha[G_t - v^{\pi}(S_t)]
\end{align}

Note that the quantity $R_{t+1} + \gamma v^{\pi}(S_{t+1}) - v^{\pi}(S_t)$ in TD($0$) is an error signal measuring the difference between the estimate value of $S_t$ and the sampled one.
This error is called the *TD error* and allows to measure how good the action leading to $S_{t+1}$ was, allowing in return to measure the improvement of the policy at each time step.
TD($0$) is thus usually preferred because it does not rely on sampling episodes, improves the policy on-line and fits naturally to non-stationary problems such as autonomous car driving.
Moreover, in neuroscience, the *TD error* is commonly used to model the *dopaminergic reward prediction error*, a well establish theory of learning by positive or negative reward signals resulting from the difference between an experienced outcome and an expected one. \cite{glimcher2011understanding}

See \ref{alg:q_learning} for a standard TD($0$) algorithm for policy improvement.

### Actor-Critic methods
Actor-Critic (AC) architectures split the agent in two separate parts interacting with each other, an actor and a critic. The actor selects an action with respect to the current state and the critic estimates and informs the actor about the quality of its action.

AC models are generally considered intuitive and neurobiologically realistic, because they can be assimilated to dopamine-based models \cite{khamassi2005actor}, and efficient. For example, the state-of-the-art deep RL implementation for Atari games is a AC model \cite{mnih2016asynchronous}.

AC models combine two methods: a value function estimator for the critic and a policy function estimator for the actor.
For the value function, the state-value function $V^{\pi}_{\phi}$ is used with a TD($0$) algorithm, this formulation allowing to consider the *TD error* as a feedback signal for the actor.
The policy function does not refer to anything we have seen before, here we do not try to estimate $\pi$ through the value function, but to optimize the policy directly.

#### Policy gradient methods
Be $\pi_{\theta}$ a policy parameterized by $\theta$, we have the following score function:

\begin{align}
J(\theta) &= \mathbb{E}_{\pi_{\theta}}[G_t]
\end{align}
We want to find $\theta^*$ such as:
\begin{align}
   \theta^* = \argmax_{\theta}  \bigtriangledown_{\theta} \mathbb{E}_{\pi_{\theta}}[G_t]
\end{align}
The policy gradient can be written as follow[^3]:
\begin{align}
  \bigtriangledown J(\theta) = \mathbb{E}_{\pi_{\theta}}[\sum\limits_{t=0}^{\infty}(R_t + \gamma V(S_{t+1}) - V(S_t))\bigtriangledown_{\theta} \ln \pi(A_t|S_t)]
\end{align}
The idea behind this formula is to use gradient ascent in order to find the parameters $\theta$ that increase the probability of finding a path where the *TD-error* is positive. An example of AC algorithm can be found in \ref{alg:AC}.


[^3]: For the sake of brevity we use the *TD error* as a baseline and do not provide the proof of derivation, see chap.13 of \cite{sutton2011reinforcement} for more details.

### Model-based methods

Model-based methods estimate the state transition probability function and the reward probability function in order to do planning.  We already saw DP learning which use the true state transition dynamic function to solve directly the *Bellman equation*. Another simple model is *Dyna-Q* \cite{sutton2011reinforcement}, which uses standard Q-learning to sample transitions and estimate the model, eventually the algorithm will reuse the estimated model to improve its Q-value function with replay.
Finally tree-based algorithms like min-max or Monte Carlo tree search  use the model to plan a forward trajectory that maximize the expected return.

# Successor representation {#SR}
## Motivation
In the previous section, we saw two main families for solving MDPs problems: model-free and model-based methods.
Model-based methods are interesting because by knowing the model they can explore the MDPs graph, thus even if the reward probability or the transition probability change locally the information is visible to all the other states. This is not the case for model-free method because the estimation of value function is always local.
However, because model-free methods use local estimations, they do not need to plan toward a terminal state or depth exploration limit like model-based algorithms, neither to store transition probability for each node that could square the memory needed (a complete graph has $n(n-1)$ transitions).
Model-free methods are computationally cheaper.

Neurobiologically speaking, we already saw that TD-learning is used to model the dopaminergic system, another point of comparison for model-free/model-based algorithms is habits vs. goal-directed behavior.
Goal-directed behavior is associated to planing, (i.e, what sequence of actions I must take to go here?), whereas habits are inflexible stimulus-response associations (i.e, reflexes).
It has long been thought that these two systems are not separated, thus an important theory is that the construction of habitual behaviors is based on multiples repetitions of goal-directed ones \cite{aarts2000habits},
or in others words the more one trains on a new task such as car driving, the less one pays attention to low-level actions like braking, changing gears, etc.

Even if there is no generally accepted model for how these two systems communicate, recent research suggests that the two systems are largely overlapping, as dopamine firing might also reflect model-based processes (\cite{doll2012ubiquity}, \cite{miller2019habits}).
As a trade-off between model-based and model-free, successor representation (SR) could be a useful formalization for modeling theses entangled systems.

## Formalization
The original formulation of successor representations (SR) \cite{dayan1993improving} is a fairly old concept (1993), but subject to a revival since a couple of years with the work of *Gershman, Samuel J.* and few others scientists \cite{gershman2012successor}, \cite{momennejad2012human}, \cite{stachenfeld2017hippocampus}, \cite{russek2017predictive}, \cite{gershman2018successor}.

The successor representation is based on re-writing the value functions of a state or state-action pair in terms of a discounted probability relation of reaching futures states or state-action pair.

Here we focus on the state-value function:
\begin{align}
  v^{\pi}(s) = \sum\limits_{s' \in \mathcal{S}} M^{\pi}(s,s')\sum\limits_{a \in \mathcal{A}(s)}\pi(a|s')R(s',a)
\end{align}
$M^{\pi}(s, s')$ ($M^{\pi} \in \mathcal{M}_{|\mathcal{S}|}(\mathbb{R})$) represent the time-discounted probability that $s'$ can be reach after $s$.
In other words, states with a close temporal relationship will have a high *SR* score and vice versa.
Moreover $M^{\pi}(s,s') = 0$ if there is no **forward** path between $s$ and $s'$ (causality).
$M^{\pi}(s,s')$ have the following notation:
\begin{align}
  M^{\pi}(s_i, s_j) = \mathbb{E}_{\pi}[\sum\limits_{k=0}^{\infty} \gamma^{k}\mathbb{I}(S_{t+k} = s_j)| S_t = s_i],
\end{align}
According to \cite{russek2017predictive}, the state-value function  can be re-written as follows:
\begin{align}
  V^{\pi}(s_i) = \sum\limits_{s_j \in \mathcal{S}} M^{\pi}(s_i, s_j) \, w(s_j)
\end{align}

Following the transition $s \rightarrow s'$, we can update the $w$:
\begin{align}
  \delta &= R(s_i,a) + \gamma_{td}v(s_j) - v(s_i) \nonumber \\
  w(i) &\leftarrow w(i) + \alpha_{td} \delta M^{\pi}(s_i, i), \quad\forall i \in \mathcal{S}
\end{align}
The objective is then to find the best predictive representation of state in terms of the reward function, thus unlike model-based, the relation between states is not absolute like in the transition probability function but behavior-dependent.

SR methods can also be described by a *Bellman equation*:
\begin{align}
  M^{\pi}(s_i, :) = \mathds{1}_{s_i} + \gamma\sum\limits_{s_j \in \mathcal{S}}T^{\pi}(s_i,s_j)M^{\pi}(s_i,:)
\end{align}
$M^{\pi}(s_i, :)$ is the SR-vector of $s_i$ state, $T^{\pi}$ the one step transition matrix, and $\mathds{1}_{s_i}$
the one-hot encoding of $s_i$.

$M^{\pi}$ can be solved in two ways, one analytically by using $T^{\pi}$:
\begin{align}
  M^{\pi}(s_i,:) = \sum\limits_{t=0}^{\infty} \gamma^{t}{T^{\pi}}^{t}(s_i,:) \nonumber \\
  M^{\pi} = (I - \gamma T^{\pi})^{-1}
\end{align}
This method is called *SR-MB* for *SR* model-based, because it presupposes that the transition matrix is known.

Another method uses *bootstrapping* for updating $M^{\pi}(s,:)$ incrementally like in TD learning:
\begin{align}
  \delta = \mathds{1}_{s_i} + \gamma M^{\pi}(s_j,:) - M^{\pi}(s_i,:) \nonumber \\
  M^{\pi}(s_i,:) \leftarrow M^{\pi}(s_i,:) + \alpha_{sr}\delta
\end{align}
This method is called SR-TD for obvious reasons, here $\delta$ is the *sensory prediction error* (*SPE*) similar to the TD *RPE* \cite{gershman2012successor}. It informs the agent if an experienced transition is less or more probable than expected.

## Successor representation using features
The *SR* can also be written with features, be $s_t$ a state, $[f_{i}(s_t)]_{i=0}^{d}$ its feature representation, this successor features (SF) encodes the expected feature values:
\begin{align}
  M^{\pi}_{i}(s_t) = \mathbb{E}_{\pi}[\sum\limits_{k=0}^{\infty}\gamma^k f_{i}(s_{t+k})| s_t]
\end{align}
The reward function is written as $R(s) = w^{T}f(s)$

Finally, we parameterize $M^{\pi}$ by $w_{i,j} \in \mathcal{M}_{d}(\mathbb{R})$ a feature-by-feature weights matrix:
\begin{align}
  M^{\pi}_{i}(s_t) \approx w_{i,j}^{T} f(s_t)
\end{align}
The weights matrix can be updated by *bootstrapping*:
\begin{align}
  \delta_{i} &= f_{i}(s_t) + \gamma M^{\pi}_{i}(s_{t+1}) - M^{\pi}_{i}(s_t) & \Delta w_{i,j} &= \delta_{i}f_{j}(s_t)
\end{align}

## Multi-scale SR
The SR matrix highly depends on the discount parameter $\gamma$. This parameter can be interpreted as a time scale horizon, the rate at which transitions distant in time are forgotten.
In this section we will see that combining multiple time horizons can provide valuable information.

### Laplace transform
According to \cite{Momennejad449470}, writing $M^{\pi}$ in terms of the parameter $\gamma$ leads to the formulation of a Laplace transform:
\begin{align}
  M^{\pi}(\gamma) = \sum\limits_{t=0}^{\infty} \gamma^{t} {T^{\pi}}^{t} &\approx \int\limits_{0}^{\infty} \gamma^{t} {T^{\pi}}^{t} \nonumber \\ &\approx \int\limits_{0}^{\infty} e^{-\sigma t}{T^{\pi}}^{t} dt \nonumber & \sigma &= - \ln(\gamma)
\end{align}
By determining the inverse Laplace transform $L^{-1}$, a transition matrix function depending on time $t$ can be obtained.
Considering two states (or features) $s_i$, $s_j$ and $T^{t}(s_i, s_j) = \Pr\{S_t = s_j | S_0 = s_i\}$, $T^{t}(s_i, s_j)$ is maximal when $t$ is equal to the time/distance between $s_i$ and $s_j$.

The true Laplace and inverse Laplace transform of this function are of course inaccessible, but \cite{Momennejad449470} and \cite{shankar2013optimally} argue that an approximation of these quantities can be made by computing several *SR* matrices with different values of the $\gamma$ parameter. An approximation of $L^{-1}$ is even provided using Post's inversion formula. \cite{post1930generalized}.

In the next section we will call $D(i,j) = \argmax_{t} T^{t}(i,j)$ for each $(i,j) \in \mathcal{S} \times \mathcal{S}$ the distance matrix. Distance and time are equivalent here, because the time step $t$ at which the *MDP* evolves is constant.

### SR-TD distance learning

Computing $D$ offers a topological information between states, allowing us to ask interesting questions such as what are the spatial neighbors of state? Is this neighborhood changing? Did the agent get closer to a goal?
These questions will be empirically explored in the next section, we will focus here only on how this approach can be used to approximate $v^{\pi}$.

One solution would be to use the inverse of the distance between two states:
\begin{align}
  v^{\pi}(s) \approx \sum\limits_{s' \in \mathcal{S}} \frac{1}{D(s,s')}w(s')
\end{align}
where $w$ is still an estimation of the immediate reward.
However, $D(s,s') \in [0, +\infty]$, so $\frac{1}{D(s,s')}$ could be unbounded.
To overcome such a limitation, we choose to compute for a state $s$ the inverse of the dense ranking of $D(s,:)$.

The ranking function will provide for each $D(s,:)$ a distance in arbitrary step number.
By definition, $D(s,s)$ will be associated to $1$, the closest neighbor will have the rank $2$, the second closer $3$, and so on and so forth.
The ranking function is chosen dense (i.e, $Rank([0.1, 0.3, 0.2, 0.2]) = [1,3,2,2]$) because we want states at the same distance to be assigned the same rank.

Finally, $v^{\pi}$ is expressed as follows:
\begin{align}
  v^{\pi}(s) &  \approx \sum\limits_{s' \in \mathcal{S}} \frac{1}{Rank(D(s,s'))}w(s') \nonumber \\
  w(i) &\leftarrow w(i) + \alpha_{td} \delta \frac{1}{Rank(D(s,i))}, \quad\forall i \in \mathcal{S}
\end{align}

The complete *actor-critic SR-TD distance* algorithm is available here \ref{alg:AC_SR-TD_distance}.

# Results {#results}
In this section, we will present and comment different experimental findings on the common and divergent points between *SR-TD*, *SR-TD distance* and *AC $TD(\lambda)$* methods. The motivation behind these experiments is to understand how the algorithms handle changes in transition and reward probability functions. If the *SR-TD distance* method allows us to extract topological information, can we use it for goal-directed planning and clustering of the environment? To carry out those comparisons, we will rely on recent work on *SR* like \cite{stachenfeld2017hippocampus}, \cite{russek2017predictive} and \cite{Momennejad449470}.

In this section each figures' caption describes the experimental process related to the observed results.


## SR-TD distance

The first experiment (@Fig:linear_maze) demonstrates the effectiveness of the inverse Laplace transform method, it show the relation between (up) $M^{\pi}$ in terms of $\gamma$ and (down) $T^{t}$ in terms of $t$.
Each line $i\_j$ correspond to (up) $M^{\pi}(i, j)$ and (down) $T^{t}(i,j)$.
The maze is itself a linear maze with $8$ states (Fig. \ref{maze:linear}).

On @Fig:linear_1, each cells have different maximum values  for $T^{t}$ whereas when the agent is on @Fig:linear_2, the maximal value of the first cell becomes the same as for the third one.
These results are coherent, because these two cells are at the same distance from @Fig:linear_2.

## SR-TD distance and transition probability function
### Previous work
\cite{russek2017predictive} tested the efficiency of SR in solving common problems in cognitive sciences like food retrieval:
The first experiment is the detour maze (Fig. \ref{maze:detour}). This problem measures the agent's ability to cope with changes in the transition probability function.

\cite{russek2017predictive} notes that when a wall is added at position $B$ *SR-TD* contrary to *SR-MB* methods are not capable to infer a policy just by sampling the new wall. Here a policy means an increasing state-value function from the left of $B$ to $R$ without going toward the wall.

Our experiment (@Fig:wall_sampling) observes how the *SR* and *distance* vectors change at position $16$ when a wall is added at position $B$.
Here *SR-TD* update the discounted probability of state $17$ to be equal to $15$, whereas the *SR-TD distance* give for state $17$ a distance comparable to the state $14$.

This suggests that even though we may still *bootstraping* the former method give us more relevant information that *SR-TD* in order to make a one step decision.

A limitation in \cite{russek2017predictive} is the way the actions in the maze are chosen. Indeed, for a state $s$, the next action is $\epsilon$-greedy determined with respect to the state-value of the neighbor states. This implies to know what are the immediate future states and this is generally not possible.
For this reason and for the sake of being as neurobiologically realistic as possible, we choose to use for both *SR-TD* and *SR-TD distance* methods an actor-critic model.

### Actor-critic results

We run a new experiment on the detour maze, describe at @Fig:detour, where we examine how convergence is altered with the addition of a wall at $B$ position. This experiment is solved with three actor-critic model: *SR-TD*, *SR-TD distance* and classic *TD($\lambda$)*
The three algorithms are trained on their best hyperparameters found via a grid-search.

Even if *SR-TD* converges toward the best path, because $\gamma$ is fixed and because we use *bootstrapping*, the agent will take a long time to take into account new unexpected transitions.
*SR-TD distance* also suffers from *bootstrapping* but has better convergence properties because the multiple time windows offer a better view of the change in distance between states.
*TD($\lambda$)* performs the worst because by being fully model-free it doesn't take advantage of model information leading to higher variance, the lack of prior information about the model is also the reason why this method have the lowest peak when the wall is added.

![Step to reward by episodes of Detour maze (Fig. \ref{maze:detour}) from the following experiment $10,000$ steps of random walk from $S$, added reward of value $10$ at $R$, $20$ episodes from $S$ to $R$, added wall at $B$, $20$ other episodes from $S$ to $R$.](../img/Detour_tolman_maze.pdf){#fig:detour width=100% height=30%}

## SR-TD distance and reward function
### Previous work

In \cite{russek2017predictive}, another experiment of food retrieval consisted of checking the ability of the agent to change its policy when a better reward is encountered.
Surprisingly, with *SR* this behavioral change is possible just by making the agent aware of the new reward position. Indeed, the model-based structure of *SR* can properly discount the reward value in terms of the discounted probability of reaching each state.
By using the *SR-TD distance* method, we hope to be able to mimic and even outperform this property by using the distance to the rewarded state instead of the probability.

### Actor-critic results
Here for this experiment we use what we called the relearn maze (Fig. \ref{maze:relearn}),we then record the capacity of the agent of choosing the best reward available, the results and experimental details are available at @Fig:relearn.

*SR-TD distance* seems to learn faster than *SR-TD* and when the reward is changed, it is capable to learn to path to the new reward $5$ times more rapidly than *SR-TD* method.

## SR-TD distance and clustering
### Previous work

The capacity of creating groups of different states have an outstanding value for both RL algorithms and cognition modeling in general. For example, the presence of a bed, a teddy bear and a pillow does not have more meaning that the objects themselves but together it can express the notion of *bedroom*. Moreover the ability of create group leads to the ability to create subgroups and thus hierarchical relationships between groups (i.e, a home is group of rooms, themselves group of objects). This is equivalent to the idea of *subgoals*, for example if I want to go to my bedroom, I would probably need to walk through the living room.
The living room is thus a *subgoal* of my goal.
*Subgoal* discovery is what makes clustering capacity appealing for sequential problem solving in general.

\cite{stachenfeld2017hippocampus} successfully describe a clustering process of states using an approximation of a *k-min-cut* algorithm on the *SR* matrix.
This method seems, in our opinion, to suffer from some limitations: first, the results depends on the $\gamma$ parameter.  \cite{stachenfeld2017hippocampus} claims that small values of $\gamma$ will produce short-term clustering, (i.e, states that are very similar) and high values will produce long-term clustering.
This is not so much a limitation but more an argument for computing multiple *SR* matrices.
Second, the *k-min-cut* clustering algorithm has as hyperparameters the number of desired cluster $k$ and relies on spectral analysis and graph theory and thus can not be neurobiologically interpreted.

To address these limitations, we will use a simple *mean-shift* clustering algorithm on the row of the $D$ matrix.
*Mean-shift* use a kernel density estimator in order to estimate attractor points which will be considered as centroids of our clustering.
Thus this algorithm find by itself the number of clusters, and only the bandwidth of the *KDE* is needed.

The arguments for using this algorithm is primarily its simplicity, the topological nature of $D$, the relative neurobiologically interpretation of the *KDE* \cite{jakel2009does} and its ability to interpret the bandwidth parameter as the desired granularity of a *subgoal*.

We present several experiments of clustering with different mazes. For each of them, we use a bandwidth estimator from \cite{scikit-learn}. This algorithm uses $q \in [0,1]$, the quantile, as a hyperparameter and computes the average maximal distance from each neighborhoods of size $q$ percent of the input data.
The higher the quantile value, the larger the bandwidth size and the fewer clusters you get.  The quantile parameter is therefore well related to the granularity of *subgoals*.

###  Maze with three rooms with SR-TD distance

From a three rooms maze (Fig. \ref{maze:3_rooms}), we use *mean-shift* with $q=0.2$, hoping to produce three clusters, one for each room. The three clusters shown on Fig. \ref{fig:3_rooms} are coherent with the input maze.

![Clustering from maze \ref{maze:3_rooms} for mean-shift ($q=0.2$) algorithm on $D$ matrix rows following $10,000$ random walk steps since $S$](../img/clusterin_3_rooms_0.pdf){#fig:3_rooms width=100% height=30%}

### Maze with five rooms with SR-TD distance
We produce the same experiment with a more complex structure, a maze with five rooms including a central one. (Fig. \ref{maze:5_rooms}).
The results from @Fig:5_rooms do not properly show the maze structure but still provide a coherent division between rooms.

![Clustering from maze \ref{maze:5_rooms} for mean-shift ($q=0.2$) algorithm on $D$ matrix rows following $10,000$ random walk steps since $S$](../img/clusterin_5_rooms_2.pdf){#fig:5_rooms width=100% height=30%}

### Maze with Russek's latent maze
Finally we launch the same experiment with a far more complex maze from \cite{russek2017predictive} (Fig. \ref{maze:latent}).
The result from @Fig:latent does provide an interesting division with a central structure, a upper structure and different colors for each dead end of the maze.

![Clustering from maze \ref{maze:latent} for mean-shift ($q=0.2$) algorithm on $D$ matrix rows following $10,000$ random walk steps since $S$](../img/clustering_latent_russek_0.pdf){#fig:latent width=100% height=30%}

We provide a clustering of this maze with different values of $q$. We can observe the formation of increasingly large rooms with a hierarchical relationship between them. The process goes on until it reaches a single piece equal to the complete labyrinth.
The results can be seen on @Fig:H_clustering

## SR-TD distance and goal-directed behavior
Finally, we tried to answer the question of knowing whether it is possible with model-based information to train an actor-critic model without reward.
One idea is to quantify whether the last agent's action has brought him closer to his goal.
For a *SR* matrix, this means that the discounted probability related to goal features from the new agent's state is higher than the same quantity from the previous state.

For the $D$ matrix, this means that the distance related to goal features from the new agent's state is lower than the same quantity from the previous state.

Concretely we fixed the $w$ vector to the wanted goal features vector and modified the *TD error* signal as:
\begin{align}
  \delta \leftarrow (M^{\pi}(S_{t+1}, :) - M^{\pi}(S_{s_{t}}), :)^{T}w
\end{align}
for *SR-TD* and:
\begin{align}
  \delta \leftarrow (D(S_{t},:) - D(S_{t+1}), :)^{T}w
\end{align}
for *SR-TD distance*.
We empirically test the capacity of this new learning method with two experiments: one with one goal and one with two successive goals.

## One goal experiment
We test the convergence toward a unique goal $R1$ with three methods *SR-TD*, *SR-TD distance* and *TD($\lambda$)*.
*TD($\lambda$)* is used as a control method with standard reward signal ($w$ is unfixed).
The results and the experimental details can be seen on @Fig:one_goal.
The three methods converge but the *SR-TD distance* converge almost instantly with a way lower first episode max-step value.

![Step to goal by episode of relearn maze (Fig. \ref{maze:latent}) from the follow experiment: fix $w$ as one-hot $R1$ encoded vector, $10,000$ step of random walk, record $20$ episodes from $S$ to $R1$](../img/Goal_directed_one_goal.pdf){#fig:one_goal width=100% height=30%}


## Two goals experiment
Even if the two methods converge, they maybe overfit the goal and may not be able to change their behavior when a new goal is given.

To check this capacity, we change the goal after some episodes.

The results and experimental details can be seen on @Fig:two_goal.

*SR-TD* method were not able to change its goal, contrary to *SR-TD distance* and *TD($\lambda$)*.
But *SR-TD distance* contrary to *TD($\lambda$)* converge almost immediately.

![Step to goal by episode of relearn maze (Fig. \ref{maze:latent}) from the follow experiment: fix $w$ as one-hot $R1$ encoded vector, $10,000$ step of random walk, record $20$ episodes from $S$ to $R1$, fix $w$ as one-hot $R2$ encoded vector, record $20$ episodes from $S$ to $R2$](../img/Goal_directed_two_goal.pdf){#fig:two_goal width=100% height=30%}

# Discussion {#discussion}

Recent experimental results on the hippocampus spatial memory ability lead researchers towards a new paradigm, *the hippocampus as predictive map*.
In this paper we have studied the properties of a mathematical framework showing valuable properties to simulate this theory, the *successor representation*.
This representation allow to encode states in terms of their future predictive positions, to construct an exponential long term memory, and to represent states by a distance vector. We call this last property *multi-scale SR*. While being still immature, this theory of *place-cells* coding for a vector of distance is supported by experiments in bats, rats and even human (\cite{sarel2017vectorial}, \cite{gauthier2018dedicated}, \cite{qasim2018neurons}).


Our main contribution is to propose a simple, neurobiologically interpretable actor-critic implementation for the *SR-TD* and *SR-TD distance* methods, and test the *multi-scale SR* framework on common and interesting cognitive problems for which it has, to the best of our knowledge, never been tested before.
Our results empirically show that *multi-scale SR*-based methods can be used for reinforcement learning and can take into account changes in transition probabilities and reward function.
These new methods can even outperform learning based one time scale like plain *SR* methods.
We think that if the agent maintains enough exploration, the *multi-scale SR* methods can maintain topological invariance for states in the local environment of the agent (i.e, the states close to its current policy).


This hypothesis is supported by the capacity of *SR-TD distance*, contrary to *SR*, to model goal-directed behaviors with non-stationary goals.
Moreover, this method can also support the theory whereby habits comes from repeated goal-directed behaviors.
Indeed, goal-directed behavior to a stationary goal without maintaining enough exploration will gradually fit to an unique path towards the goal, the distance information will only be relevant for the states in that path leading to state-action relation, which is a definition of habits.

We shown the capacity of *multi-scale SR* to cluster states with a simple and neurobiologically compatible algorithm *mean-shift*. The bandwidth parameter for *mean-shift* can be see as the wanted granularity of the clustering process leading to the automatic discovery of hierarchical clusters. In turn, these clusters could be seen as abstract *subgoals* which the agent could manipulate to succeed in his main objective.
This idea is a central preoccupation of *hierarchical reinforcement learning* and for cognitive research of spatial problems and sequential reasoning in general because hierarchical thinking allow to encapsulate low-level spatial information inside abstract labels like, home, kitchen, school, street, etc. and to draw relation between them.

Our work was focus on gridworld problems and linear approximation functions. The natural next step will be to adapt and tests these method on complex environment, either in a cognitive science perceptive with for example 3D food retrieval problems in *Animal-AI olympics* \cite{crosby2019animal} or for standard RL problems like Atari games.
From here one could also study the clustering capacity of *multi-scale SR* methods with more complex feature vectors.

Finally, another still unexplored area of research would be working to provide a link between the *SR* models and biologically more realistic hippocampus models using spike neural networks like \cite{gonner2017predictive}.

\medskip

\bibliographystyle{splncs04}
\bibliography{../bib/papers}

\newpage
\appendix

# Maze layouts

## linear mazes
``` {#maze:linear}
+---+---+---+---+---+---+---+---+
| S                             |
+---+---+---+---+---+---+---+---+
```


## Detour maze

```{#maze:detour}
+---+---+---+---+---+---+
|                       |   
+   +---+---+---+---+   +   
|   |               |   |   
+   +---+---+---+---+   +---+
| S         B             R |
+   +---+---+---+---+   +---+
|   |               |   |   
+   +               +   +   
|   |               |   |   
+   +               +   +  
|   |               |   |
+   +---+---+---+---+   +
|                       |
+---+---+---+---+---+---+
```
## Relearn maze
```{#maze:relearn}
+---+---+---+---+---+---+---+
|   |   |   |   |       | R1|
+---+   +---+   +---+   +   +
| S                 |   |   |
+---+   +---+   +---+   +   +
|   |   |   |   |       |   |
+   +   +   +   +---+---+   +
|   |   |   |               |
+   +   +   +   +---+---+   +
|   |   |   |   |       |   |
+---+   +   +   +   +   +   +
|       |   |   |       |   |
+   +   +   +   +   +   +   +
|   |   |   |   |       | R2|
+---+---+---+---+---+---+---+
```
## Three rooms maze
```{#maze:3_rooms}
+---+---+---+---+---+
| S     |           |
+   +   +   +   +   +
|                   |
+   +   +   +   +   +
|       |           |
+---+---+---+---+   +
|                   |
+   +   +   +   +   +
|                   |
+   +   +   +   +   +
|                   |
+---+---+---+---+---+
```
## Five Rooms maze
```{#maze:5_rooms}
+---+---+---+---+---+---+---+---+---+---+
| S                                     |
+   +   +   +   +   +   +   +   +   +   +
|                   |                   |
+   +   +   +---+---+---+---+   +   +   +
|           |                           |
+---+   +---+   +   +   +   +---+   +---+
|           |               |           |
+   +   +   +   +---+---+---+   +   +   +
|                                       |
+   +   +   +   +   +   +   +   +   +   +
|                   |                   |
+---+---+---+---+---+---+---+---+---+---+
```
\newpage
## Russek's latent maze

```{#maze:latent}
+---+---+---+---+---+---+---+---+---+---+
|   |   |       |   |       |           |
+---+   +---+---+   +---+   +   +   +   +
| S                     |   |           |
+   +   +   +   +   +   +   +   +---+---+
|                       |   |   |       |
+---+   +---+---+   +---+   +   +   +   +
|   |   |       |   |       |   |       |
+   +   +   +   +   +---+---+   +   +   +
|   |   |       |               |       |
+   +   +   +---+   +   +   +   +   +   +
|   |   |   |                   |       |
+   +   +   +   +   +---+---+   +   +   +
|   |   |   |       |       |   |       |
+---+   +   +   +   +   +---+   +   +   +
|       |   |       |   |       |       |
+   +   +   +---+   +   +   +   +---+---+
|       |       |   |   |               |
+---+   +   +   +   +   +---+   +   +   +
|   |   |       |   |       |           |
+---+---+---+---+---+---+---+---+---+---+
```
# Solving methods for MDPs {#sol_methods}

## Dynamic programming ##

### Optimal value and action-value functions ###

Finite MDPs allow to easily define a way to find the optimal policy.
Indeed, if $\mathcal{S}$ and $\mathcal{A}$ are finite the number of behaviors, or $\pi$ policy is finite $(|\mathcal{S}|^{|\mathcal{A}|})$, furthermore we can define a partial ordering on policy $\pi$ such as $\pi' \geq \pi \Leftrightarrow  v^{\pi'}(s) \geq v^{\pi}(s), \forall s \in \mathcal{S}$.
There is thus at least one optimal policy $\pi*$.
The optimal policy defines the optimal state-value function $v^{\pi*}$ as:

\begin{align}
  v^{\pi*}(s) = \max_{\pi} v^{\pi}(s), \quad\forall s \in \mathcal{S},
\end{align}

and the optimal action-value function $q^{\pi*}$:
\begin{align}
  q^{\pi*}(s,a) = \max_{\pi} q^{\pi}(s,a), \quad\forall (s,a) \in \mathcal{S} \times \mathcal{A}(s)
\end{align}

Finally, because the optimal state-value and action-value satisfy the *Bellman equation*, we define the *Bellman optimality equation* for $v^{\pi*}(s)$ as follow:

\begin{align}
  v^{\pi* }(s) &= \max_{a \in \mathcal{A}(s)} \mathbb{E}_{\pi* }[R_{t+1} + \gamma v^{\pi*}(S_{t+1})|S_t = s, A_t = a] \nonumber \\
                  &= \max_{a \in \mathcal{A}(s)} \sum\limits_{s' \in \mathcal{S}} P(s'|s,a)[r(s,a) + \gamma v^{\pi*}(s')]
\end{align}

The same goes for $q^{\pi*}(s, a)$:
\begin{align}
  q^{\pi* }(s,a) &=
  \mathbb{E}_{\pi*}[R_{t+1} +
  \gamma \max_{a' \in \mathcal{A}(S_{t+1})} q^{\pi*} (S_{t+1}, a')|S_t = s, A_t = a] \nonnumber \\
                  &= \sum\limits_{s' \in \mathcal{S}} P(s'|s,a)[R(s,a) + \gamma \max_{a' \in A} q^{\pi* }(s', a')]
\end{align}

The optimal policy is the one where, for each state $s$, we compute the best deterministic action a = $\pi(s)$or the best probability vector $\pi(.|s)$, regarding the next possible reward and then follow the optimal policy for the rest of the sequence.
In the next section we will see that this formulation leads to a natural fixed-point algorithm.

### Value iteration ###

If the number of actions in the policy $\pi$ is finite, the policy set can be partially ordered and we can easily construct a policy $\pi'$ from a given policy $\pi$ with an iterative process so that $\pi' \geq \pi$.
This *policy improvement* process is defined as the following form:
\begin{align}
  v^{\pi'}(s) &= \max_{a \in \mathcal{A}(s)} \mathbb{E}[R_{t+1} + \gamma v^{\pi}(S_{t+1}) | S_t = s, A_t = a], \forall s \in \mathcal{S} \nonumber \\
                &= \max_{a \in \mathcal{A}(s)} \sum\limits_{s' \in \mathcal{S}} P(s' | s,a)[R(s,a) + \gamma v^{\pi }(s')], \forall s \in \mathcal{S}
\end{align}

Dynamic Programming (DP) algorithms converge to $\pi*$ \cite{sutton2011reinforcement} with a good convergence speed \cite{bonet2007speed}, but relies on knowing the transition dynamics $P$ (i.e, DP is a *model-based* solution).
This requirement is generally impossible or very hard to satisfy on non-trivial problems leading to model estimation or model-free methods.

This process have a simple form of dynamic programming where each state
$V^{\pi}(s)$ is save inside a cell of an array.
\begin{algorithm}[H]
  \SetKwInOut{Input}{input}
  \SetKwInOut{Output}{output}
  \Input{The transition probability function: $P$}
  \Input{The reward function: $R$}
  \Input{The discount parameter: $\gamma$}
  \Input{Precision parameter: $\theta$}
  \Input{The action set: $\mathcal{A}$}
  \Input{The state set: $\mathcal{S}$}
  \KwResult{$\pi \approx \pi*$}
  \BlankLine
  \DontPrintSemicolon
  \SetAlgoLined
  Initialize array V from prior knowledge or by a 0-array\;
  \BlankLine
  \Repeat{$\Delta < \theta$}{
    $\Delta \gets 0$\;
    \ForEach{$s \in \mathcal{S}$}{
      $v \gets V(s)$\;
      $V(s) \gets \max_{a \in A(s)} \sum\limits_{s' \in \mathcal{S}} P(s'|s,a)[R(s,a) + \gamma v^{\pi }(s')]$\;
      $\Delta \gets \max(\Delta, |v - V(s)|)$ \;
    }
  }
  \BlankLine
  Output a deterministic policy, $\pi \approx \pi*$, such that\;
  $\pi(s) = \argmax_{a \in \mathcal{A}(s)} \sum\limits_{s' \in \mathcal{S}} P(s'|s,a)[R(s,a) + \gamma v^{\pi}(s')]$\;
\caption{Value iteration}
\label{alg:DP}
\end{algorithm}

## Monte Carlo methods ##

According to \cite{sutton2011reinforcement}, Monte Carlo methods are model-free algorithms with three principals advantages compared to DP: 1) they do not need to construct a model because they sample it, 2) they do not require to sample the entire model to be useful (i.e, the set of starting states can be a subset of $\mathcal{S}$).
Monte Carlo methods draw multiple samples of state-action-reward sequences called *episodes* ($S_0, A_0, R_1, S_1, A_1, R_2,\dots,S_{H-1} A_{H-1},R_H$) from an arbitrary policy $\pi$ and use them to estimate $q^{\pi}(s, a) \forall(s,a) \in \mathcal{S} \times \mathcal{A}(s)$.
The estimation of $q^{\pi}(s,a)$ is given by the empiric average of the discounted reward associated.
Then the policy $\pi$ is improved by acting greedy with respect to the action-value estimation.

This simple version of Monte Carlo learning have some limitations: because we learn *on-policy* (i.e, we improve the policy $\pi$ used to sample transitions), the result is highly dependent on sampling and can converge to a sub-optimal policy.

A common solution is to learn *off-policy* with a behavioral policy $b$ used to generate episodes which improve a second policy $\pi$.
In order to have an estimation of $\pi$ from $b$, the two policy must fulfill the *assumption of coverage*: $\pi(s|a) > 0 \implies b(s|a) > 0$. For $b$, a $\epsilon$-greedy policy with respect to $\pi$ is generally enough.
Because we sample episodes from a different distribution than the one we want to improve, we need to use *importance sampling* to make the result from $b$ relevant for $\pi$ \cite{sutton2011reinforcement}.

## Q learning algorithms

\begin{algorithm}[H]
  \SetKwInOut{Input}{input}
  \SetKwInOut{Output}{output}
  \Input{The discount parameter: $\gamma$}
  \Input{The average parameter: $\alpha$}
  \Input{The action set: $\mathcal{A}$}
  \Input{The state set: $\mathcal{S}$}
  \KwResult{$\pi \approx \pi*$}
  \BlankLine
  \DontPrintSemicolon
  \SetAlgoLined
  Initialize array Q from prior knowledge or by a $0$-array\;
  $Q(terminal-state, .) = 0$\;
  \BlankLine
  \ForEach{episodes}{
    Initialize first state $s \in \mathcal{S}$\;
    Initialize first action $a \in \mathcal{A}(s)$\;
    \ForEach{state in episode}{
      take action $a$, observe $r$, $s'$\;
      $\delta \gets r + \gamma \max_{a' \in \mathcal{A}} Q(s',a') - Q(s,a)$\;
      $Q(s,a) \gets Q(s,a) + \alpha \delta$\;
      $s \gets s'$\;
      $a \gets a'$\;
    }
  }
  \BlankLine
\label{alg:q_learning}
\caption{Q-learning}
\end{algorithm}

\begin{algorithm}[H]
  \SetKwInOut{Input}{input}
  \SetKwInOut{Output}{output}
  \Input{The action set: $\mathcal{A}$}
  \Input{The state set: $\mathcal{S}$}
  \Input{The discount parameter: $\gamma$}
  \KwResult{$\pi \approx \pi*$}
  \BlankLine
  \DontPrintSemicolon
  \SetAlgoLined
  Initialize array Q from prior knowledge or by a $0$-array\;
  Initialize $\theta$ the features vector\;
  $Q_{\theta}(terminal-state, .) = 0$\;
  \BlankLine
  \ForEach{episodes}{
    Initialize first state $s \in \mathcal{S}$\;
    Initialize first action $a \in \mathcal{A}(s)$\;
    \ForEach{state in episode}{
      take action $a$, observe $r$, $s'$\;
      $\delta \gets r + \gamma \max_{a' \in \mathcal{A}}
      \hat{Q}_{\theta}(s',a') - \hat{Q}_{\theta}(s,a)$\;
      $\theta \gets \theta + \alpha \delta \varphi(s, a)$\;
      $s \gets s'$\;
      $a \gets a'$\;
    }
  }
  \BlankLine
\label{alg:q_learning_approx}
\caption{Q-learning with function approximation}
\end{algorithm}

## Actor critic algorithms
\begin{algorithm}[H]
  \SetKwInOut{Input}{input}
  \SetKwInOut{Output}{output}
  \Input{a differentiable policy: $\pi(a|s, \theta)$}
  \Input{a differentiable state-value: $v(s,w)$}
  \Input{The discount parameter: $\gamma$}
  \Input{Steps size $\alpha^{\theta}$, $\alpha^{w}$}
  \KwResult{$\pi \approx \pi*$}
  \BlankLine
  \DontPrintSemicolon
  \SetAlgoLined
  Initialize policy parameter $\theta \in \mathbb{R}^d$ and state-value weights $w \in \mathbb{R}^d$\;
  $V(terminal-state, w) = 0$\;
  \BlankLine
  \Repeat{$forever$}{
    Initialize $S$ the first state\;
    \While{$S$ is not terminal}{
      $A \sim \pi(.|S, \theta)$\;
      Take action A, observe S^', R\;
      $\delta \gets R + \gamma V(S^', w) - V(S, w)$\;
      $w \gets w + \alpha^{w}\delta\bigtriangledown_{w} V(S,w)$\;
      $\theta \gets \alpha^{\theta}\delta\bigtriangledown_{\theta} \ln \pi(A|S, \theta)$\;
      $S \gets S^'\;
    }
  }
  \BlankLine
\label{alg:AC}
\caption{Actor critic algorithm from \cite{sutton2011reinforcement}}
\end{algorithm}

The AC algorithms of *SR-TD* and *SR-TD distance* replace $\bigtriangledown_{w} V(S,w)$ by $M^{\pi}(S,:)$ and $D(S, :)$ respectively.
The policy function is parametrized by a simple feature to action matrix, called $U$ ($U \in \mathbb{R}^{|\mathcal{A}(s)| \times |\varphi(S_t)|}$), the action is sampled from $\pi(.|S_t) = softmax(U\varphi(S_t))$.
The policy gradient $\bigtriangledown_{\theta} \ln \pi(A|S, \theta)$ is simply $\varphi(S_t)$.

## SR-TD distance algorithm

\begin{figure}
\begin{algorithm}[H]
  \SetKwInOut{Input}{input}
  \SetKwInOut{Output}{output}
  \Input{Number of windows: $n$}
  \Input{Number of features: $d$}
  \Input{Number of actions: $a$}
  \Input{Precision parameter: $k$}
  \Input{Minimal temporal step: $t^{*}_{\min}$}
  \Input{Temporal delta: $c$}
  \Input{SR learning rate: $\alpha_{sr}$}
  \Input{State action network learning rate: $\alpha_{A}$}
  \Input{Immediate reward vector learning rate: $\alpha_{w}$}
  \Input{Precision parameter: $k$}
  \BlankLine
  \DontPrintSemicolon
  \SetAlgoLined
  \BlankLine
  SR discount vector: $\gamma_{sr}$\;
  SR $3D$ matrix: $W_{sr} \in \mathbb{R}^{n \times d \times d}$\;
  $t^{*} \gets t^{*}_{\min}(1 + c) \quad \forall c \in [1,\dots, n]$\;
  $\sigma \gets \frac{k}{t^{*}}$\;
  $\gamma_{sr} \gets e^{-\sigma}$\;
  $I\gets Identity(d)$\;
  $W_{sr} \gets [I]^{n}$\;
  $D \in \mathcal{M}_{d}(\mathbb{R})$\;
  $A \in \mathbb{R}^{a \times d}$\;
  $w \in \mathbb{R}^{d}$\;
  \Repeat{$forever$}{
    Initialize first states $S_{sr}$, $S_{dist}$, $S$\;
    \While{features \emph{f} is not terminal}{
      $action \sim softmax(A \cdot f)$\;
      Take action, observe $f^{'}$, and $r$\;
      $S^{'}_{sr} \gets [W_{sr}[0]^{T}f^{'},\dots, W_{sr}[n]^{T}f^{'}]$\;
      $S^{'}_{dist} \gets dense-rank(e^{-(\frac{k}{D^{T}f^{'}})})$\;
      $S^{'} \gets {S^{i}_{dist}}^{T}w$ ($S^{'} = 0$ if $f^{'}$ is terminal)\;
      $\delta \gets r + \gamma S^{'} - S$ \;
      update $W_{sr}[i]$ SR matrix with $\gamma_{SR}[i]$, $\forall i \in [1,\dots,n]$\;
      $A \gets A + \alpha_{A} \delta f$\;
      $w \gets w + \alpha_{w} \delta \frac{S_{dist}} {{\left\Vert\left S_{dist} \right\Vert\right}^{2}_{2}}$\;
      $S \gets S^{'}$\;
      $S_{dist} \gets S^{'}_{dist}$\;
      $S_{sr} \gets S^{'}_{sr}$\;
      $D \gets compute-distance(W_{sr}, k, t^{*}, \sigma)$\;
    }
  }
  \BlankLine
\label{alg:AC_SR-TD_distance}
\caption{Actor critic SR-TD distance algorithm}
\end{algorithm}
\end{figure}

\begin{figure}
\begin{algorithm}[H]
  \SetKwInOut{Input}{input}
  \SetKwInOut{Output}{output}
  \Input{SR $3D$ matrix: $W_{sr}$}
  \Input{Precision parameter: $k$}
  \Input{Sigma vector: $\sigma$}
  \Input{Temporal vector: $t^{*}$}
  \Output{Distance matrix: $D$}
  \BlankLine
  \DontPrintSemicolon
  \SetAlgoLined
  \BlankLine
    $c\gets \frac{(-1)^{k}}{k!} \sigma^{k+1}$\;
    \For{$i\gets0$ \KwTo $d$}{
      \For{$j\gets0$ \KwTo $d$}{
        $d_{\sigma}\gets \frac{d^{k}}{d^{\sigma}}([W_{sr}[0,i,j], \dots, W_{sr}[d,i,j]])$\;
        \tcp*{$\frac{d^{k}}{d^{\sigma}}$ can be computed by finite-derivative method}\;
        $D[i,j] \gets t^{*}[\argmax_{t} c \cdot d_{\sigma}[t]]$\;
      }
    }
  \BlankLine
\label{alg:compute}
\caption{Compute-distance procedure}
\end{algorithm}
\end{figure}

<div id="fig:linear_maze">
  ![Distance vector of the first cell](../img/linear_maze_0_maze.pdf){#fig:linear_1 width=50% height=24%}
  ![Distance vector of the second cell](../img/linear_maze_1_maze.pdf){#fig:linear_2 width=50% height=24%}

  ![Distance vector of the third cell](../img/linear_maze_2_maze.pdf){#fig:linear_3 width=50% height=24%}
  ![Distance vector of the fourth cell](../img/linear_maze_3_maze.pdf){#fig:linear_4 width=50% height=24%}

  ![Distance vector of the fifth cell](../img/linear_maze_4_maze.pdf){#fig:linear_5 width=50% height=24%}
  ![Distance vector of the sixth cell](../img/linear_maze_5_maze.pdf){#fig:linear_6 width=50% height=24%}

  ![Distance vector of the seventh cell](../img/linear_maze_6_maze.pdf){#fig:linear_7 width=50% height=24%}
  ![Distance vector of the eighth cell](../img/linear_maze_7_maze.pdf){#fig:linear_8 width=50% height=24%}

  SR-multi scale and inverse Laplacian results from a $8$ cases linear maze explored by $10,000$ random steps  
</div>

<div id="fig:wall_sampling">
  ![SR vector $M(16,:)$](../img/SR_wall_sampling.pdf){#fig:wall_SR width=100% height=50%}

  ![Distance vector $D(16,:)$](../img/SR_distance_wall_sampling.pdf){#fig:wall_SR_distance width=100% height=50%}

  $M(16,:)$ and $D(16,:)$ vectors of the maze (\ref{maze:detour}) resulting from last $50$ iteration of the following experiment: $10,000$ steps of random walk from $S$, reward of value $10$ added at $R$, $20$ episodes to reward (from $S$ to $R$), wall added at $B$.
  $50$ times sampling of a one-step transition at the left of $B$.
</div>

<div id="fig:relearn">
![SR-TD](../img/simple_Relearn_tolman_maze_SR-TD_AC.pdf){#fig:reward_SR width=100% height=30%}

![SR-TD distance](../img/simple_Relearn_tolman_maze_SR-distance.pdf){#fig:reward_SR_distance width=100% height=30%}

Step to reward by episodes of relearn maze (Fig. \ref{maze:relearn}) from the following experiment: $10,000$ steps of random walk from $S$, added reward of value $10$ at $R1$, sampled $R1$ reward $30$ times, $20$ episodes from $S$ to $R1$, added reward of value $100$ at $R2$, sampled $R2$ $30$ times, $20$ episodes from $S$ to $R1$ or $R2$. Blue dots result from taking the best possible reward and vice versa for orange ones.
</div>

<div id="fig:H_clustering">
![$q = 0.10$](../img/clustering_latent_russek_0_10.pdf){#fig:latent_10 width=50% height=20%}
![$q = 0.15$](../img/clustering_latent_russek_0_15.pdf){#fig:latent_15 width=50% height=20%}

![$q = 0.20$](../img/clustering_latent_russek_0_20.pdf){#fig:latent_20 width=50% height=20%}
![$q = 0.25$](../img/clustering_latent_russek_0_25.pdf){#fig:latent_25 width=50% height=20%}

![$q = 0.30$](../img/clustering_latent_russek_0_30.pdf){#fig:latent_30 width=50% height=20%}
![$q = 0.35$](../img/clustering_latent_russek_0_35.pdf){#fig:latent_35 width=50% height=20%}

![$q = 0.4$](../img/clustering_latent_russek_0_40.pdf){#fig:latent_40 width=100% height=30%}

Hierarchical clustering from maze \ref{maze:latent} for mean-shift algorithm on $D$ matrix rows following $10,000$ random walk steps since $S$.
</div>
